--Nico73 Modding
--24/08/2022

-- V1.0
--Owervrite function for value needsRolling missing in mapFruitsType.xml

-- V1.1
--Compatibility with version 1.7.0, override new version of mapFruitType.xml

noMoreRolling = {};

function noMoreRolling:loadFruitTypeCultivation(superFunc, fruitType, xmlFile, key)

	local potato = g_fruitTypeManager:getFruitTypeByName("potato");
	local maize = g_fruitTypeManager:getFruitTypeByName("maize");
	local sunflower = g_fruitTypeManager:getFruitTypeByName("sunflower");	
	local sugarBeet = g_fruitTypeManager:getFruitTypeByName("sugarBeet");	
	local sugarCane = g_fruitTypeManager:getFruitTypeByName("sugarCane");
	local cotton = g_fruitTypeManager:getFruitTypeByName("cotton");	
	local sorghum = g_fruitTypeManager:getFruitTypeByName("sorghum");
	local poplar = g_fruitTypeManager:getFruitTypeByName("poplar");
	local grass = g_fruitTypeManager:getFruitTypeByName("grass");	
	local oilseedRadish = g_fruitTypeManager:getFruitTypeByName("oilseedRadish");
	local meadow = g_fruitTypeManager:getFruitTypeByName("meadow");
	
	if potato ~= nil then
		
		potato.needsSeeding = true;
		potato.allowsSeeding = true;
		potato.directionSnapAngle = 0;
		potato.alignsToSun = false;
		potato.seedUsagePerSqm = 0.38;
		potato.plantsWeed = true;
		potato.needsRolling = false;
	end;

	if maize ~= nil then
		
		maize.needsSeeding = true;
		maize.allowsSeeding = true;
		maize.directionSnapAngle = 0;
		maize.alignsToSun = false;
		maize.seedUsagePerSqm = 0.04;
		maize.plantsWeed = true;
		maize.needsRolling = false;
	end;
	
	if sunflower ~= nil then
		
		sunflower.needsSeeding = true;
		sunflower.allowsSeeding = true;
		sunflower.directionSnapAngle = 0;
		sunflower.alignsToSun = true;
		sunflower.seedUsagePerSqm = 0.03;
		sunflower.plantsWeed = true;
		sunflower.needsRolling = false;
	end;
	
	if sugarBeet ~= nil then
		
		sugarBeet.needsSeeding = true;
		sugarBeet.allowsSeeding = true;
		sugarBeet.directionSnapAngle = 0;
		sugarBeet.alignsToSun = false;
		sugarBeet.seedUsagePerSqm = 0.04;
		sugarBeet.plantsWeed = true;
		sugarBeet.needsRolling = false;
	end;

	if sugarCane ~= nil then
		
		sugarCane.needsSeeding = true;
		sugarCane.allowsSeeding = true;
		sugarCane.directionSnapAngle = 0;
		sugarCane.alignsToSun = false;
		sugarCane.seedUsagePerSqm = 1.20;
		sugarCane.plantsWeed = true;
		sugarCane.needsRolling = false;
	end;
	
	if cotton ~= nil then
		
		cotton.needsSeeding = true;
		cotton.allowsSeeding = true;
		cotton.directionSnapAngle = 0;
		cotton.alignsToSun = false;
		cotton.seedUsagePerSqm = 0.05;
		cotton.plantsWeed = true;
		cotton.needsRolling = false;
	end;

	if sorghum ~= nil then
		
		sorghum.needsSeeding = true;
		sorghum.allowsSeeding = true;
		sorghum.directionSnapAngle = 0;
		sorghum.alignsToSun = false;
		sorghum.seedUsagePerSqm = 0.02;
		sorghum.plantsWeed = true;
		sorghum.needsRolling = false;
	end;
	
	if poplar ~= nil then
		
		poplar.needsSeeding = true;
		poplar.allowsSeeding = true;
		poplar.directionSnapAngle = 0;
		poplar.alignsToSun = false;
		poplar.seedUsagePerSqm = 0.15;
		poplar.plantsWeed = false;
		poplar.needsRolling = false;
	end;
	
	if grass ~= nil then
		
		grass.needsSeeding = false;
		grass.allowsSeeding = true;
		grass.directionSnapAngle = 0;
		grass.alignsToSun = false;
		grass.seedUsagePerSqm = 0.03;
		grass.plantsWeed = false;
		grass.needsRolling = false;
	end;

	if oilseedRadish ~= nil then
		
		oilseedRadish.needsSeeding = true;
		oilseedRadish.allowsSeeding = true;
		oilseedRadish.directionSnapAngle = 0;
		oilseedRadish.alignsToSun = false;
		oilseedRadish.seedUsagePerSqm = 0.01;
		oilseedRadish.plantsWeed = false;
		oilseedRadish.needsRolling = false;
	end;
	
	if meadow ~= nil then
		
		meadow.needsSeeding = false;
		meadow.allowsSeeding = false;
		meadow.directionSnapAngle = 0;
		meadow.alignsToSun = false;
		meadow.seedUsagePerSqm = 0.03;
		meadow.plantsWeed = false;
		meadow.needsRolling = false;
	end;
	
	if fruitType ~= nil and fruitType.name ~= "potato" or fruitType.name ~= "maize" or fruitType.name ~= "sunflower" or fruitType.name ~= "sugarBeet" or fruitType.name ~= "sugarCane" or fruitType.name ~= "cotton" or fruitType.name ~= "sorghum" or fruitType.name ~= "poplar" or fruitType.name ~= "grass" or fruitType.name ~= "oilseedRadish" or fruitType.name ~= "meadow" then
		fruitType.needsSeeding = Utils.getNoNil(getXMLBool(xmlFile, key .. ".cultivation#needsSeeding"), Utils.getNoNil(fruitType.needsSeeding, true))
		fruitType.allowsSeeding = Utils.getNoNil(getXMLBool(xmlFile, key .. ".cultivation#allowsSeeding"), Utils.getNoNil(fruitType.allowsSeeding, true))
		fruitType.directionSnapAngle = Utils.getNoNilRad(getXMLFloat(xmlFile, key .. ".cultivation#directionSnapAngle"), Utils.getNoNil(fruitType.directionSnapAngle, 0))
		fruitType.alignsToSun = Utils.getNoNil(getXMLBool(xmlFile, key .. ".cultivation#alignsToSun"), Utils.getNoNil(fruitType.alignsToSun, false))
		fruitType.seedUsagePerSqm = Utils.getNoNil(getXMLFloat(xmlFile, key .. ".cultivation#seedUsagePerSqm"), Utils.getNoNil(fruitType.seedUsagePerSqm, 0.1))
		fruitType.plantsWeed = Utils.getNoNil(getXMLBool(xmlFile, key .. ".cultivation#plantsWeed"), Utils.getNoNil(fruitType.plantsWeed, true))
		fruitType.needsRolling = Utils.getNoNil(getXMLBool(xmlFile, key .. ".cultivation#needsRolling"), Utils.getNoNil(fruitType.needsRolling, true))
		local cultivationStates = nil
		local i = 0

		while true do
			local cultivationKey = string.format("%s.cultivation.state(%d)", key, i)

			if not hasXMLProperty(xmlFile, cultivationKey) then
				break
			end

			local state = getXMLInt(xmlFile, cultivationKey .. "#state")

			if state ~= nil then
				if cultivationStates == nil then
					cultivationStates = {}
				end

				table.insert(cultivationStates, state)
			end

			i = i + 1
		end

		fruitType.cultivationStates = cultivationStates

		return true
	end

	return false
end

FruitTypeManager.loadFruitTypeCultivation = Utils.overwrittenFunction(FruitTypeManager.loadFruitTypeCultivation, noMoreRolling.loadFruitTypeCultivation)